// Time-stamp: <1999-02-03 22:17:18 zaykin> (Dmitri Zaykin)
//
// This is the code for keeping [a/2 --- 1-a/2] percentile points
//

#include "stl_hdrs.h"

class Crs 
{
    multiset <double, less<double> > u;
    multiset <double, greater<double> > l;
public:
    Crs () { lsz=usz=0; }
    size_t lsz, usz;
    double low, upp;
    void Init (double a, long n) { 
        usz=lsz=(size_t)(n*a/2.0); 
        low=0.0;
        upp=1.0;
    }
    Crs (double a, long n) { Init(a, n); }
    void Update (double p) {
        l.insert (p), u.insert (p);
        if (l.size() > lsz) l.erase(l.begin());
        if (u.size() > usz) u.erase(u.begin());
        low = *(l.begin());
        upp = *(u.begin());
    }
    friend ostream &operator << (ostream& os, const Crs & w) {
        return (os << *(w.l.begin()) << " -- " << *(w.u.begin()));
    }
};

