// Time-stamp: <2001-06-12 10:51:53 dvz90620> (Dmitri Zaykin)

#include "dir_smp.h"

void Cumul(Vd& cf, const Vd& af)
{
    double csum = 0;
    for (size_t j=0; j<af.size(); j++) {
        csum += af[j];
        cf[j] = csum;
    }
}

void CmDiri(Vd& p, double pr, Gauss& Ga)
{
    double sum = 0;
    Vd tmp = p;    
    for(size_t j=0; j<tmp.size(); j++) {
        tmp[j] = Gengam(1.0, pr, Ga);
        sum += tmp[j];
    }
    for(size_t j=0; j<tmp.size(); j++) tmp[j] /= sum;
    Cumul(p, tmp);
}

void Cumul(Vd& af)
{
    Vd cf = af;
    double csum = 0;
    for (size_t j=0; j<af.size(); j++) {
        csum += af[j];
        cf[j] = csum;
    }
    af = cf;
}

void Diri(Vd& p, double pr, Gauss& Ga)
{
    double sum=0;
    for(size_t j=0; j<p.size(); j++) {
        p[j] = Gengam(1.0, pr, Ga);
        sum += p[j];
    }
    for(size_t j=0; j<p.size(); j++) p[j] /= sum;
}

double CSearch(Vd& s, double c, int *index)
{
    int l=0; int r=s.size();
    while(r >= l)
    {
        int x=(l+r)/2;
        if(x > 0 && s[x-1] <= c && s[x] >= c) { return s[*index=x]; }
        else if(!x) { return s[*index=0]; }
        if(c < s[x]) r=x;
        else l=x+1;
    }
    *index = -1;
    return -1;
}
