#include "mystrings.h"

// Returns zero if 'tok' contains none of the characters in 'stuff'  
int InString(const char* tok, const char* stuff)
{
    string t=tok;
    return t.find_first_of(stuff, 0) < t.length();
}

int InString(const string& t, const string& stuff)
{
    return t.find_first_of(stuff, 0) < t.length();   
}

//  Example: any digits in av[1]?
//  int main(int ac, char **av) {
//      cout << InString(av[1], "0123456789") << "\n";
//  }

void split_string (const string& tok, const string& sep, vector<string>& w)
{
    w.clear();
    int n = tok.length();
    int start=tok.find_first_not_of(sep), stop;
    while (start >= 0 && start < n) {
        stop = tok.find_first_of(sep, start);
        if (stop < 0 || stop > n) stop = n;
        w.push_back(tok.substr(start, stop-start));
        start = tok.find_first_not_of(sep, stop+1);
    }
}

int GetNumWords(const string& tok, vector<string>& w, 
                const string& sep=" \t")
{
    int n = tok.length();
    int start=tok.find_first_not_of(sep), stop;
    while (start >= 0 && start < n) {
        stop = tok.find_first_of(sep, start);
        if (stop < 0 || stop > n) stop = n;
        w.push_back(tok.substr(start, stop-start));
        start = tok.find_first_not_of(sep, stop+1);
    }
    return w.size();
}
